2 sixping sixping 于 2016.04.03 16:35 提问

按书上写了一段java捕获异常的代码,不知道问题出在哪里

源代码如下:
package com.Sixping.Ncre;

public class Rethrow {
public static void rt() throws Exception {//定义方法,抛出Exception类的异常
System.out.println("old exception in rt()");
throw new Exception("thrown from rt()");
}
public static void wq() throws Throwable {//定义方法,调用rt(),捕获rt()抛出的异常
try {
rt();
} catch (Exception e) {
System.out.println("Inside wq(),e.printStackTrace():");
e.printStackTrace(); //输出堆栈使用情况
throw e; //重新抛出异常
}
}
public static void main(String[] args) throws Throwable {
try {
wq(); //产生被重新抛出的对象
} catch (Exception e) {
System.out.println("Caught in main,e.printStackTrace():");
e.printStackTrace(); //再次输出堆栈信息
}
}
}

运行报错如下:
old exception in rt()

java.lang.Exception: thrown from rt()
at com.Sixping.Ncre.Rethrow.rt(Rethrow.java:6)
at com.Sixping.Ncre.Rethrow.wq(Rethrow.java:10)
at com.Sixping.Ncre.Rethrow.main(Rethrow.java:19)
java.lang.Exception: thrown from rt()
at com.Sixping.Ncre.Rethrow.rt(Rethrow.java:6)
at com.Sixping.Ncre.Rethrow.wq(Rethrow.java:10)
at com.Sixping.Ncre.Rethrow.main(Rethrow.java:19)
Inside wq(),e.printStackTrace():
Caught in main,e.printStackTrace():

求大神解答

3个回答

wojiushiwo945you
wojiushiwo945you   Ds   Rxr 2016.04.03 18:16
已采纳

没有错误啊,你不就是测试异常抛出嘛,流程是这样的;
首先,rt()方法抛出了异常,然后你在wq()方法中捕获并上抛出,直至main方法中捕获的是Exception,但是wq抛出的Throwable异常没有处理,所以被main方法继续抛出给虚拟机了。
代码运行是正确的,这不是运行时报错,而是你就是测试的throw e,抛出异常后你在捕获分支中使用的是e.printStack打印堆栈信息了。这个流程是对的,你可以注释调用e.printStackTrace(); 就能发现不会打印堆栈日志了。

CSDNXIAOD
CSDNXIAOD   2016.04.03 16:42

关于Java异常一段很有意思的代码
----------------------biu~biu~biu~~~在下问答机器人小D,这是我依靠自己的聪明才智给出的答案,如果不正确,你来咬我啊!

ljheee
ljheee   Rxr 2016.04.04 21:38

代码没有什么语法、逻辑错误。
rt()方法抛出了异常,在wq()方法中捕获并继续抛出,抛给main方法,main方法继续抛给虚拟机,虚拟机能做的就是终止程序。
这些行堆栈日志 信息由e.printStackTrace(); 打印输出

Csdn user default icon
上传中...
上传图片
插入图片
准确详细的回答,更有利于被提问者采纳,从而获得C币。复制、灌水、广告等回答会被删除,是时候展现真正的技术了!